<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
          "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>

<HEAD>
<TITLE>JFLA 2000</TITLE>
</HEAD>

<BODY BGCOLOR="#FFFFFF">

<H1 ALIGN=CENTER>JFLA 2000: relecture du papier 11</H1>

<P>Numero du papier: 11
<P>Titre du papier: Safe value I/O in Caml
<P>Auteurs: J. Furuse, P. Weis

<P>Nom du rapporteur: C. Dubois

<P>Confiance en la note: 3
<!-- 1 : je n'ai pas compris car ce n'est pas mon domaine.
     2 : j'ai compris, mais je ne domine pas le sujet.
     3 : j'ai tout compris car c'est mon domaine. -->

<P>Notation du papier: 4,5
<!-- 1 : a rejeter; 2 : ininteressant; 3 : acceptable;
     4 : bon papier; 5: tres bon papier -->

<P>Commentaires aux auteurs:<P>

<P>Le papier decrit un mecanisme permettant des entrees/sorties s\^ures
de valeurs complexes  en Ocaml.

<P>Papier bien ecrit, pedagogique qui enonce clairement les problemes
lies aux entrees/sorties. Belle application des <<generics>>.
La toute derniere partie (coerce et import) est moins convaincante
car elle est trop rapidement presentee, avec des erreurs syntaxiques
qui la rendent difficile a lire.


<P>L'hypothese de depart qui consiste a confondre 2 types si leur
<<nameless type definitions>> sont identiques, quoique bien motivee
dans le papier par la pratique, est neanmoins perturbante dans le
contexte d'un langage fortement type. comme Caml ou l'equivalence des types 
n'est pas structurelle.

<P>Une section qui mentionnerait d'autres approches manque.

<P>Remarques de detail :
<P> Les clauses Assumption1 et Assumption2 ne sont pas tres claires : 
la premiere est une constatation mais le statut de la seconde n'est pas clair.

<P>p1 
<P>It is also basically (au lieu de Is Is)

<P>p2 
<P>there is no way (au lieu de there no way)

<P>Un exemple sans contrainte de typage serait mieux venu (plus
accessible en cette partie introductive) pour bien
montrer que le typage est correct mais qu'il y a erreur a l'execution.
du genre let f () = let y = input_value ic in y^y
puis execution de f ==> Segmentation fault.


<P>p3 
<P><< int ra int >>
<P>fin de la page : un blanc entre \delta et is a dynamic variable
<P>idem haut p4 \delta of the type scheme 

<P>p4
<P>les tildes dans le type de print 
<P>bas de la page : a dynamic value (au lieu de values)

<P>p6 :
 <P>reference en avant de \tau_e desagreable 
<P>distinguer syntaxiquement l'* des defbody et des types produits.

<P>p7 substitution (au lieu de substation)
<P>La definition de l'isomorphisme externe n'est plus utilisee ensuite.

<P>L'introduction de la section 6 n'introduit par clairement que c'est ce
qui est fait dans la section. 
<P>Notation 1 << \tau from a program ....>> is denoted ...

<P>p8 
<P>dans bin :
<P>the record labels .... in the same way as in their definition

<P>paragraphe suivant : phrase concernant Cnst : bin returns the integer
n-1 (au lieu de n)
<P>Lists have a predefined type, ...

<P>Introduire le systeme de types et la notation \Gamma |> e : \tau

<P>p10 -11 : les fonctions generiques compilees ont ici des suffixes
_comp alors qu'au debut les suffixes etaient _object.


<P>p11 : encore des ra dans les << >>

<P>p12 : this extension of the generic type system ensures ... (au lieu
de With ...)

<P>The annotation of export_value in export_x ....

<P>export_x is now safe .... to use the dyn constructor to insert ...

<P>We also need to work ... in order to obtain polymorphic encapsulation.

<P>p13 
<P>1ere phrase : a monomorphic one.

<P>3 syntaxes sont utilisees pour les types dans coerce et import : x:\tau , <x:tau>> et x:<<tau>>

<P>p14 : 
<P>derniere ligne : ajouter safely : to handle safely polymorphic
run time arguments.
 

<P>Commentaires reserves au comite de programme:<P>
<P>Bon papier, inte'ressant,  bien ecrit malgre quelques typos.
Une traduction en fran\c{c}ais m'avait ete promise au moment de la
soumission. A voir maintenant !

Motivations interessantes et bien exposees.

</BODY>
</HTML>




